<!DOCTYPE html>
<html lang="" xml:lang="">
  <head>
    <title>Taller de R: Estadística y programación</title>
    <meta charset="utf-8" />
    <meta name="author" content="Eduard Martínez" />
    <script src="libs/header-attrs/header-attrs.js"></script>
    <link href="libs/remark-css/fc.css" rel="stylesheet" />
    <link href="libs/remark-css/default.css" rel="stylesheet" />
    <link href="libs/remark-css/default-fonts.css" rel="stylesheet" />
  </head>
  <body>
    <textarea id="source">
class: center, middle, inverse, title-slide

# Taller de R: Estadística y programación
## Lectura 16: Shiny y Rmarkdown
### Eduard Martínez
### Universidad de los Andes | <a href="https://github.com/taller-R">ECON-1302</a>

---



name: contenido

# Hoy veremos 

1. [Introducción a Rmarkdown](#rm)

2. [Introducción a Shiny](#shiny)

    
&lt;!-----------------------------------&gt;
&lt;!--- Introducción a Rmarkdown ---&gt;
&lt;!-----------------------------------&gt;
---
class: inverse, center, middle
name: intro

# [1. Introducción a Rmarkdown](#rm)

&lt;html&gt;&lt;div style='float:left'&gt;&lt;/div&gt;&lt;hr color='#FF007F' size=1px width=796px&gt;&lt;/html&gt;

---
# 1.1. ¿Que es R Markdown?

Markdown es un lenguaje de marcado que facilita la aplicación de formato a un texto empleando una serie de caracteres de una forma especial. En R podemos integrar este leguaje para generar informes y documentos automatizados.

# 1.2. Elementos de un archivo .Rdm 

Podemos identificar tres elementos dentro de un archivo .Rdm:

+ Encabezado: Esta parte del .Rdm se encuentra al inicio del documento y está contenido en los siguientes caracteres `---`. Allí se deben escribir todas las funciones que permitan asignar la configuración deseada a mi documento.

+ Texto: Mientras en R el formato primario son las funciones, en R Markdown se considera el texto plano como el formato primario. Al momento de compilar R Markdown lo define como *ordinary text without R code*. 

+ Código: Está compuesto por todas las líneas de código que se ejecutan en la consola de R y que permiten obtener los resultados que se muestran en el *output* del .Rdm. 

---
# 1.3. Encabezado YAML

Como mencionamos anteriormente, este va al inicio de nuestro documento y determina los parámetros generales del reporte a compilar. 

- **HTML**

```r
---
title: "Introducción a R Markdown" 
subtitle: "Taller de R, clase 15"
author: "Eduard Martinez"
date: "5/20/2020"
output: html_document
---
```

- **LaTeX**

```r
---
title: "Introducción a R Markdown" 
subtitle: "Taller de R, clase 15"
author: "Eduard Martinez"
date: "5/20/2020"
header-includes:    
      - \usepackage{float} 
output: pdf_document
---
```

---
# 1.4. Hoja de referencia

[Aquí](https://rstudio.com/wp-content/uploads/2015/03/rmarkdown-spanish.pdf) puede encontrar la hoja de referencia de R Markdown.

&lt;div align="center"&gt;
&lt;img src="pics/h_referencia.png" heigth=100&gt;
&lt;/div&gt;

---
# 1.5. Help

Vamos a la pagina de [https://rmarkdown.rstudio.com](https://rmarkdown.rstudio.com/authoring_basics.html) y revisemos las sintaxis básicas de R Markdown. En las siguientes páginas web podemos encontrar material de apoyo que nos sirve para iniciar con R Markdown. 

+ [Bookdown](https://bookdown.org/gboccardo/manual-ED-UCH/introduccion-al-uso-de-rmarkdown-para-la-compilacion-de-resultados-de-rstudio-en-diferentes-formatos.html) 

+ [r4ds](https://es.r4ds.hadley.nz/r-markdown.html)

+ [Bookdown](https://bookdown.org/yihui/rmarkdown/notebook.html#using-notebooks)

+ [kableExtra](https://cran.r-project.org/web/packages/kableExtra/vignettes/awesome_table_in_html.html#CellText_Specification)

&lt;!----------------------------&gt;
&lt;!--- Introducción a Shiny ---&gt;
&lt;!----------------------------&gt;
---
class: inverse, center, middle
name: example
# [2. Introducción a Shiny](#shiny)

&lt;html&gt;&lt;div style='float:left'&gt;&lt;/div&gt;&lt;hr color='#FF007F' size=1px width=796px&gt;&lt;/html&gt;

---
# 2.0. Qué es una dashboard de Shiny?

Un shiny app o una dashboard, es una interfaz de usuario (UI) conectada a una seccion de R corriendo en una computadora (server): 
&lt;div align="center"&gt;
&lt;img src="http://juliawrobel.com/tutorials/images/what_is_shiny.png"&gt;
&lt;/div&gt;
Tomado de: [http://juliawrobel.com](http://juliawrobel.com/tutorials/images/what_is_shiny.png)

---
# 2.1. Imputs de shiny

&lt;div align="center"&gt;
&lt;img src="pics/shiny.png"&gt;
&lt;/div&gt;

Podemos ver la hoja de referencia de Shiny [aquí](https://shiny.rstudio.com/images/shiny-cheatsheet.pdf).

---
# 2.2. Help
Veamos algunos ejemplos de Shiny: [https://github.com/rstudio/shiny-examples](https://github.com/rstudio/shiny-examples)


```r
library(shiny)
runExample(example = "04_mpg")
```

&lt;div align="center"&gt;
&lt;img src="pics/shiny-example.png"&gt;
&lt;/div&gt;

---
# 2.3. Alojar la app en el host de shiny

1. Ir a [https://www.shinyapps.io](https://www.shinyapps.io)

2. Crean un usuario y una contraseña  (preferiblemente usen el correo de su cuenta de GitHub).

3. Generen un dominio para su cuenta (yo uso eduard-martinez, el nombre de mi usuario en GitHub).

4. Obtener un tocken.

5. Publicar app.

&lt;!---------------------&gt;
&lt;!---    Hoy vimos  ---&gt;
&lt;!---------------------&gt;
---
class: inverse, center, middle
name: view

# [Hoy vimos...](#contenido1)
&lt;html&gt;&lt;div style='float:left'&gt;&lt;/div&gt;&lt;hr color='#FF007F' size=1px width=796px&gt;&lt;/html&gt;

---
#  Hoy vimos...

- ☑ [Introducción a Rmarkdown](#rm)

- ☑ [Introducción a Shiny](#shiny)


    </textarea>
<style data-target="print-only">@media screen {.remark-slide-container{display:block;}.remark-slide-scaler{box-shadow:none;}}</style>
<script src="https://remarkjs.com/downloads/remark-latest.min.js"></script>
<script>var slideshow = remark.create({
"transition": "slide",
"self_contained": true,
"highlightStyle": "github",
"highlightLines": true,
"countIncrementalSlides": false
});
if (window.HTMLWidgets) slideshow.on('afterShowSlide', function (slide) {
  window.dispatchEvent(new Event('resize'));
});
(function(d) {
  var s = d.createElement("style"), r = d.querySelector(".remark-slide-scaler");
  if (!r) return;
  s.type = "text/css"; s.innerHTML = "@page {size: " + r.style.width + " " + r.style.height +"; }";
  d.head.appendChild(s);
})(document);

(function(d) {
  var el = d.getElementsByClassName("remark-slides-area");
  if (!el) return;
  var slide, slides = slideshow.getSlides(), els = el[0].children;
  for (var i = 1; i < slides.length; i++) {
    slide = slides[i];
    if (slide.properties.continued === "true" || slide.properties.count === "false") {
      els[i - 1].className += ' has-continuation';
    }
  }
  var s = d.createElement("style");
  s.type = "text/css"; s.innerHTML = "@media print { .has-continuation { display: none; } }";
  d.head.appendChild(s);
})(document);
// delete the temporary CSS (for displaying all slides initially) when the user
// starts to view slides
(function() {
  var deleted = false;
  slideshow.on('beforeShowSlide', function(slide) {
    if (deleted) return;
    var sheets = document.styleSheets, node;
    for (var i = 0; i < sheets.length; i++) {
      node = sheets[i].ownerNode;
      if (node.dataset["target"] !== "print-only") continue;
      node.parentNode.removeChild(node);
    }
    deleted = true;
  });
})();
(function() {
  "use strict"
  // Replace <script> tags in slides area to make them executable
  var scripts = document.querySelectorAll(
    '.remark-slides-area .remark-slide-container script'
  );
  if (!scripts.length) return;
  for (var i = 0; i < scripts.length; i++) {
    var s = document.createElement('script');
    var code = document.createTextNode(scripts[i].textContent);
    s.appendChild(code);
    var scriptAttrs = scripts[i].attributes;
    for (var j = 0; j < scriptAttrs.length; j++) {
      s.setAttribute(scriptAttrs[j].name, scriptAttrs[j].value);
    }
    scripts[i].parentElement.replaceChild(s, scripts[i]);
  }
})();
(function() {
  var links = document.getElementsByTagName('a');
  for (var i = 0; i < links.length; i++) {
    if (/^(https?:)?\/\//.test(links[i].getAttribute('href'))) {
      links[i].target = '_blank';
    }
  }
})();
// adds .remark-code-has-line-highlighted class to <pre> parent elements
// of code chunks containing highlighted lines with class .remark-code-line-highlighted
(function(d) {
  const hlines = d.querySelectorAll('.remark-code-line-highlighted');
  const preParents = [];
  const findPreParent = function(line, p = 0) {
    if (p > 1) return null; // traverse up no further than grandparent
    const el = line.parentElement;
    return el.tagName === "PRE" ? el : findPreParent(el, ++p);
  };

  for (let line of hlines) {
    let pre = findPreParent(line);
    if (pre && !preParents.includes(pre)) preParents.push(pre);
  }
  preParents.forEach(p => p.classList.add("remark-code-has-line-highlighted"));
})(document);</script>

<script>
slideshow._releaseMath = function(el) {
  var i, text, code, codes = el.getElementsByTagName('code');
  for (i = 0; i < codes.length;) {
    code = codes[i];
    if (code.parentNode.tagName !== 'PRE' && code.childElementCount === 0) {
      text = code.textContent;
      if (/^\\\((.|\s)+\\\)$/.test(text) || /^\\\[(.|\s)+\\\]$/.test(text) ||
          /^\$\$(.|\s)+\$\$$/.test(text) ||
          /^\\begin\{([^}]+)\}(.|\s)+\\end\{[^}]+\}$/.test(text)) {
        code.outerHTML = code.innerHTML;  // remove <code></code>
        continue;
      }
    }
    i++;
  }
};
slideshow._releaseMath(document);
</script>
<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
(function () {
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.src  = 'https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-MML-AM_CHTML';
  if (location.protocol !== 'file:' && /^https?:/.test(script.src))
    script.src  = script.src.replace(/^https?:/, '');
  document.getElementsByTagName('head')[0].appendChild(script);
})();
</script>
  </body>
</html>
